;-  TLCplay
;   V00.99?
;
;   (C) 2001   Levente Hrsfalvi    ( Levente@terrasoft.hu )
;
;   Released on ... still experimental, not released.
;
;
;
;   This program (will be ;-) ) free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation; either version 2 of the License, or
;   (at your option) any later version.
;
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the Free Software
;   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;
;   Compiling needs:
;
;   - Table Driven Assembler 3.0.1 or later (ASM)
;   - ComLink V0.98 or later (linking)
;
;   Link with -th option
;

         .module player

#ifndef LO
#define LO(x) (x&$ff)
#define HI(x) (x>>8)
#endif

#ifndef song
         *= $2000

#define speed 4
#endif

#ifdef ffskip
effinit = 1
#else
effinit = 0
#endif

pt       =$d0

p_init   jmp _init                              ;initialize
p_play   jmp _play                              ;irq player
p_mult   jmp _snd                               ;multi-speed entry

               ;0123456789abcdef
         .text "PLAYER AND MUSIC"
         .text " BY TLC/CORONERS"
         .text " (C) 2001.02.12 "

i_frqtab .export i_frqtab
frqtab
         .block $7a

_init    ldx #$01                               ;Player init
_i1
         lda #2
         sta durcnt,x
         lda #1                                 ;Let the player read instrument
         sta _finish,x                          ;data
         lda #0
         sta arpcnt,x
         sta volcnt,x
         sta trkpos,x
         sta transp,x
         sta sctpos,x
         sta arppos,x
         sta sldpos,x
         sta sldadd,x
         sta volpos,x
         dex
         bpl _i1
         sta $ff11
         rts

_play    ldx #1                                 ;Play...
_p1      dec durcnt,x                           ;Duration counter
         bmi _setsnd
         beq _procsct
         lda durcnt,x
         cmp #$01
         beq _proctr1
         bne _pe

_proctr1 jmp _proctrk

_setsnd  lda _keyon,x
         bpl _nonew
         lda _anote1,x
         sta anote,x

         lda #0
         sta _keyon,x

         ldy asnd,x                             ;Init sound!!!
         lda arp,y                              ;Instrument arpeggio startpos
         beq _noarpl                            ;0? --> don't touch arpeggio
         sta arppos,x
         lda #effinit                           ;Arpeggio accu not zeroed!!!
         sta arpcnt,x                           ;Arpeggio wait cnt

_noarpl  lda slp,y
         beq _nosldl
         sta sldpos,x
         lda #0
         sta sldacl,x
         sta sldach,x
#ifdef ffskip
         lda #effinit
#endif
         sta sldcnt,x

_nosldl  lda vop,y                              ;Volume program startpos
         beq _snend                             ;0 --> don't touch
         sta volpos,x                           ;Init volume prog pos
         lda #effinit                           ;Volume accu not inited!!!
         sta volcnt,x                           ;Set counter

_snend   lda adur,x                             ;Reload duration counter
         sta durcnt,x
_pe      dex                                    ;And do it again until all
         bpl _p1                                ;tracks were served
         jmp _snd

_nonew   beq _snend
         lda #0
         sta _keyon,x
         sta arppos,x
         sta arpac,x
         sta sldpos,x
         sta volpos,x
         lda #$84
         sta volacc,x
         bne _snend

_procsct lda sctadl,x                           ;
         sta pt                                 ;
         lda sctadh,x                           ;Sector instruction decode.
         sta pt+1                               ;Load sector
         ldy sctpos,x                           ;parameters to pt and y...

         lda (pt),y                             ;Next sector instruction
         cmp #$7f                               ;priority-trick
         bcc _note
         cmp #$c0                               ;Above $c0? --> SND
         bcc _notsnd
         and #$3f                               ;Store current sound number
         sta asnd,x
         iny
         lda (pt),y                             ;Next instruction
_notsnd  cmp #$80                               ;Above $80? --> DUR
         bcc _notdur
         and #$3f                               ;Store current duration
         sta adur,x
         iny
         lda (pt),y                             ;Next instruction
_notdur  cmp #$7f                               ;$7f? --> END
         beq _fin1
_note    cmp #$7d                               ;$7d is keep, $7e is off
         bcs _off
         clc
         adc transp,x
         sta _anote1,x                          ;No... it's a NOTE
         sec
_off     sbc #$7d                               ;_keyon is below 0 if new note
         sta _keyon,x                           ;0 if no new note, 1 when off
         iny
         lda (pt),y
_fin     cmp #$7f
         bne _psend
_fin1    lda #1
         sta _finish,x
_psend   tya
         sta sctpos,x
         jmp _pe

_proctrk lda _finish,x                          ;Did the sector play finish?
         beq _pe                                ;Not, skip track processing
         dec _finish,x                          ;Yes... ack it
         ldy trkpos,x                           ;Load track position
         lda trkadl,x                           ;Load track start address
         sta pt
         lda trkadh,x
         sta pt+1
         lda (pt),y                             ;Load track command
         cmp #$80                               ;Let's give time priority
         bcc _notrans                           ;for the most frequent command
         cmp #$ff                               ;$ff? --> Jumpxx
         bne _nojmp
         iny                                    ;Next byte=jump pos
         lda (pt),y
         tay                                    ;Transfer to pos
         lda (pt),y                             ;Load track command
_nojmp   cmp #$80                               ;Below $80?
         bcc _notrans
         and #$7f                               ;Above... --> Transpose.
         sta transp,x                           ;Set low 7 bits to transp+x
         iny
         lda (pt),y                             ;Next byte
_notrans sta _foo1                              ;push it...
         iny                                    ;...so you can increase the
         tya                                    ;track pointer before dealing
         sta trkpos,x                           ;with the sector number byte.
_foo1    =*+1
         ldy #0                                 ;take it back...
         lda sctaddl,y                          ;Load sector address low
         sta sctadl,x                           ;store it...
         lda sctaddh,y
         sta sctadh,x                           ;High byte...
         lda #0                                 ;Zero sector pos.
         sta sctpos,x
         dex
         bmi _snd                               ;Get outta here
         jmp _p1                                ;next one...

; the sound programs

_snd     ldx #1

_sndl    ldy arppos,x                           ;Load arpeggio program position
         beq _noarp                             ;0? --> skip everything
         dec arpcnt,x                           ;Decrement counter
         bpl _noarp                             ;positive? --> dec counter, bye

         lda ar0,y                              ;Zero... process arpeggio table
         cmp #$ff                               ;$ff--> jump
         bne _noarjmp
         lda ar1,y                              ;Load parameter as new position
         bne _ar1
         sta arppos,x                           ;Zero--> get outta here
         beq _noarp
_ar1     tay                                    ;Else continue
         lda ar0,y
_noarjmp sta arpstat,x
         and #$3f                               ;Mask timer bits
         sta arpcnt,x
         iny
         tya
         sta arppos,x                           ;store new pos

         lda ar1-1,y
         sta arpac,x

_noarp   ldy sldpos,x                           ;Load slide program position
         beq _nosld                             ;0? --> skip everything
         dec sldcnt,x                           ;Decrement counter
         bpl _nonewsl                           ;positive? --> dec counter, bye

         lda sl0,y                              ;Negative... process arpeggio table
         cmp #$ff                               ;$ff--> jump
         bne _nosljmp
         lda sl1,y                              ;Load parameter as new position
         bne _sl1
         sta sldpos,x                           ;Zero--> get outta here
         beq _nosld
_sl1     tay                                    ;Else continue
         lda sl0,y
_nosljmp sta sldstat,x
         and #$7f                               ;Mask timer bits
         sta sldcnt,x
         lda sl1,y
         sta sldadd,x
         iny
         tya
         sta sldpos,x                           ;store new pos

_nonewsl lda sldadd,x                           ;Slide... dammit
         bmi _slneg
         ldy #0
         .byte $2c
_slneg   ldy #$ff
         clc
         adc sldacl,x
         sta sldacl,x
         tya
         adc sldach,x
         sta sldach,x

_nosld   ldy volpos,x                           ;Process volume
         beq _novol
         dec volcnt,x
         bpl _novol

         lda vo0,y
         cmp #$ff
         bne _novojmp
         lda vo1,y
         bne _vo1
         sta volpos,x
         beq _novol
_vo1     tay
         lda vo0,y
_novojmp sta volcnt,x
         lda vo1,y
         sta volacc,x
         iny
         tya
         sta volpos,x

_novol   lda volacc,x
         bpl _cfreq
         lda #$fd
         sta $ff0e,x
         lda #$03
         jmp _wrx

_cfreq   lda arpstat,x
         and #$c0
         bmi _frabs
         bne _freqo
         lda arpac,x
         and #$7f
         clc
         adc anote,x
         tay
         lda frqtab,y
         sta pt
         cpy #$19
         bcc _cl5
         ldy #$19
_cl5     lda frqtab+$60,y
         tay
         jmp _clsum

_freqo   ldy anote,x
         lda frqtab,y
         sta pt
         cpy #$19
         bcc _cl6
         ldy #$19
_cl6     lda frqtab+$60,y
         tay
         lda arpac,x
         bpl _cl7
         dey
_cl7     clc
         adc pt
         sta pt
         bcc _clsum
         iny
_cl8     jmp _clsum

_frabs   and #$40
         bne _frqabs
         lda arpac,x
         and #$7f
         tay
         lda frqtab,y
         sta pt
         cpy #$19
         bcc _cl9
         ldy #$19
_cl9     lda frqtab+$60,y
         tay
         jmp _clsum

_frqabs  lda arpac,x
         sta pt
         ldy #0

_clsum   lda sldstat,x
         bpl _clv
         lda pt
         sta $ff0e,x
         tya
         jmp _wrx

_clv     lda pt
         clc
         adc sldacl,x
         sta $ff0e,x
         tya
         adc sldach,x

_wrx     cpx #$1
         beq _wr1
         and #$03
ff12mask =*+1                                 ;Don't forget to set it...
_v02     ora #$c4
         sta $ff12
         bne _sndloop
_wr1     sta $ff10

_sndloop dex                                  ;Babe, one more time ;-)
         bmi _snd1e
         jmp _sndl
_snd1e

;Now set TED volume and control bits

         lda volacc                           ;Volume sum of Voice0 + 1
         clc
         adc volacc+1
         lsr a
         and #$0f                             ;mask low bits
         bit arpstat+1
         bvs _nsoff
         bit arpac+1                          ;Then determine and add
         bmi _nson                            ;control bits.
_nsoff   ora #$30
         .byte $2c
_nson    ora #$50
         sta $ff11                            ;Got it...

_snde    rts

_keyon   .byte 0,0
_finish  .byte 0,0

trkpos   .byte 0,0
transp   .byte 0,0
durcnt   .byte 0,0
adur     .byte 0,0
asnd     .byte 0,0
anote    .byte 0,0
_anote1  .byte 0,0
sctpos   .byte 0,0
sctadl   .byte 0,0
sctadh   .byte 0,0

arpcnt   .byte 0,0
arppos   .byte 0,0
arpstat  .byte 0,0
arpac    .byte 0,0

sldcnt   .byte 0,0
sldpos   .byte 0,0
sldstat  .byte 0,0
sldadd   .byte 0,0
sldacl   .byte 0,0
sldach   .byte 0,0

volcnt   .byte 0,0
volpos   .byte 0,0
volacc   .byte 0,0

trkadl   .byte LO(trk0),LO(trk1)
trkadh   .byte HI(trk0),HI(trk1)

#ifndef song

trk0     = $2d00
trk1     = $2e00

sounds   = $40
sndstart = $3000

arp      = sndstart
slp      = sndstart + sounds
vop      = sndstart + (sounds*2)

ar0      = $3300
ar1      = $3400
sl0      = $3500
sl1      = $3600
vo0      = $3700
vo1      = $3800

         *= $2c00
sctaddl  .byte 0,0,0,0,0,0,0,0
         .byte 0,0,0,0,0,0,0,0
         .byte 0,0,0,0,0,0,0,0
         .byte 0,0,0,0,0,0,0,0
         .byte 0,0,0,0,0,0,0,0
         .byte 0,0,0,0,0,0,0,0
         .byte 0,0,0,0,0,0,0,0
         .byte 0,0,0,0,0,0,0,0

sctaddh  .byte $40,$41,$42,$43,$44,$45,$46,$47
         .byte $48,$49,$4a,$4b,$4c,$4d,$4e,$4f
         .byte $50,$51,$52,$53,$54,$55,$56,$57
         .byte $58,$59,$5a,$5b,$5c,$5d,$5e,$5f
         .byte $60,$61,$62,$63,$64,$65,$66,$67
         .byte $68,$69,$6a,$6b,$6c,$6d,$6e,$6f
         .byte $70,$71,$72,$73,$74,$75,$76,$77
         .byte $78,$79,$7a,$7b,$7c,$7d,$7e,$7f
         .byte $80,$81,$82,$83,$84,$85,$86,$87
         .byte $88,$89,$8a,$8b,$8c,$8d,$8e,$8f
         .byte $90,$91,$92,$93,$94,$95,$96,$97
         .byte $98,$99,$9a,$9b,$9c,$9d,$9e,$9f
         .byte $a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7
         .byte $a8,$a9,$aa,$ab,$ac,$ad,$ae,$af
         .byte $b0,$b1,$b2,$b3,$b4,$b5,$b6,$b7
         .byte $b8,$b9,$ba,$bb,$bc,$bd,$be,$bf

#endif
         .end
